Index: trunk/src/libs/xpcom18a4/Makefile.kmk
===================================================================
--- trunk/src/libs/xpcom18a4/Makefile.kmk	(revision 101840)
+++ trunk/src/libs/xpcom18a4/Makefile.kmk	(revision 101841)
@@ -192,5 +192,4 @@
 	nsprpub/pr/include/prproces.h \
 	nsprpub/pr/include/prshm.h \
-	nsprpub/pr/include/prshma.h \
 	nsprpub/pr/include/prsystem.h \
 	nsprpub/pr/include/prthread.h \
@@ -509,5 +508,4 @@
 	nsprpub/pr/src/md/prosdep.c \
 	nsprpub/pr/src/memory/prshm.c \
-	nsprpub/pr/src/memory/prshma.c \
 	nsprpub/pr/src/misc/pratom.c \
 	nsprpub/pr/src/misc/prdtoa.c \
Index: trunk/src/libs/xpcom18a4/nsprpub/pr/include/nspr.h
===================================================================
--- trunk/src/libs/xpcom18a4/nsprpub/pr/include/nspr.h	(revision 101840)
+++ trunk/src/libs/xpcom18a4/nsprpub/pr/include/nspr.h	(revision 101841)
@@ -61,5 +61,4 @@
 #include "prproces.h"
 #include "prshm.h"
-#include "prshma.h"
 #include "prsystem.h"
 #include "prthread.h"
Index: trunk/src/libs/xpcom18a4/nsprpub/pr/include/private/primpl.h
===================================================================
--- trunk/src/libs/xpcom18a4/nsprpub/pr/include/private/primpl.h	(revision 101840)
+++ trunk/src/libs/xpcom18a4/nsprpub/pr/include/private/primpl.h	(revision 101841)
@@ -746,23 +746,4 @@
 #define _PR_MD_DELETE_SHARED_MEMORY  _MD_DeleteSharedMemory
 
-extern PRFileMap* _md_OpenAnonFileMap(
-    const char *dirName,
-    PRSize      size,
-    PRFileMapProtect prot
-);
-#define _PR_MD_OPEN_ANON_FILE_MAP _md_OpenAnonFileMap
-
-extern PRStatus _md_ExportFileMapAsString(
-    PRFileMap *fm,
-    PRSize    bufSize,
-    char      *buf
-);
-#define _PR_MD_EXPORT_FILE_MAP_AS_STRING _md_ExportFileMapAsString
-
-extern PRFileMap * _md_ImportFileMapFromString(
-    const char *fmstring
-);
-#define _PR_MD_IMPORT_FILE_MAP_FROM_STRING _md_ImportFileMapFromString
-
 
 
Index: trunk/src/libs/xpcom18a4/nsprpub/pr/include/prshma.h
===================================================================
--- trunk/src/libs/xpcom18a4/nsprpub/pr/include/prshma.h	(revision 101840)
+++ 	(revision )
@@ -1,279 +1,0 @@
-/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
-/* ***** BEGIN LICENSE BLOCK *****
- * Version: MPL 1.1/GPL 2.0/LGPL 2.1
- *
- * The contents of this file are subject to the Mozilla Public License Version
- * 1.1 (the "License"); you may not use this file except in compliance with
- * the License. You may obtain a copy of the License at
- * http://www.mozilla.org/MPL/
- *
- * Software distributed under the License is distributed on an "AS IS" basis,
- * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
- * for the specific language governing rights and limitations under the
- * License.
- *
- * The Original Code is the Netscape Portable Runtime (NSPR).
- *
- * The Initial Developer of the Original Code is
- * Netscape Communications Corporation.
- * Portions created by the Initial Developer are Copyright (C) 1999-2000
- * the Initial Developer. All Rights Reserved.
- *
- * Contributor(s):
- *
- * Alternatively, the contents of this file may be used under the terms of
- * either the GNU General Public License Version 2 or later (the "GPL"), or
- * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
- * in which case the provisions of the GPL or the LGPL are applicable instead
- * of those above. If you wish to allow use of your version of this file only
- * under the terms of either the GPL or the LGPL, and not to allow others to
- * use your version of this file under the terms of the MPL, indicate your
- * decision by deleting the provisions above and replace them with the notice
- * and other provisions required by the GPL or the LGPL. If you do not delete
- * the provisions above, a recipient may use your version of this file under
- * the terms of any one of the MPL, the GPL or the LGPL.
- *
- * ***** END LICENSE BLOCK ***** */
-
-/*
-** prshma.h -- NSPR Anonymous Shared Memory
-**
-** NSPR provides an anonymous shared memory based on NSPR's PRFileMap
-** type. The anonymous file-mapped shared memory provides an inheritable
-** shared memory, as in: the child process inherits the shared memory.
-** Compare the file-mapped anonymous shared memory to to a named shared
-** memory described in prshm.h. The intent is to provide a shared
-** memory that is accessable only by parent and child processes. ...
-** It's a security thing.
-** 
-** Depending on the underlying platform, the file-mapped shared memory
-** may be backed by a file. ... surprise! ... On some platforms, no
-** real file backs the shared memory. On platforms where the shared
-** memory is backed by a file, the file's name in the filesystem is
-** visible to other processes for only the duration of the creation of
-** the file, hopefully a very short time. This restricts processess
-** that do not inherit the shared memory from opening the file and
-** reading or writing its contents. Further, when all processes
-** using an anonymous shared memory terminate, the backing file is
-** deleted. ... If you are not paranoid, you're not paying attention.
-** 
-** The file-mapped shared memory requires a protocol for the parent
-** process and child process to share the memory. NSPR provides two
-** protocols. Use one or the other; don't mix and match.
-** 
-** In the first protocol, the job of passing the inheritable shared
-** memory is done via helper-functions with PR_CreateProcess(). In the
-** second protocol, the parent process is responsible for creating the
-** child process; the parent and child are mutually responsible for
-** passing a FileMap string. NSPR provides helper functions for
-** extracting data from the PRFileMap object. ... See the examples
-** below.
-** 
-** Both sides should adhere strictly to the protocol for proper
-** operation. The pseudo-code below shows the use of a file-mapped
-** shared memory by a parent and child processes. In the examples, the
-** server creates the file-mapped shared memory, the client attaches to
-** it.
-**
-** First protocol.
-** Server:
-**
-**   fm = PR_OpenAnonFileMap(dirName, size, FilemapProt); 
-**   addr = PR_MemMap(fm); 
-**   attr = PR_NewProcessAttr();
-**   PR_ProcessAttrSetInheritableFileMap( attr, fm, shmname );
-**   PR_CreateProcess(Client); 
-**   PR_DestroyProcessAttr(attr);
-**   ... yadda ...
-**   PR_MemUnmap( addr );
-**   PR_CloseFileMap(fm);
-**
-**
-** Client: 
-**   ... started by server via PR_CreateProcess()
-**   fm = PR_GetInheritedFileMap( shmname );
-**   addr = PR_MemMap(fm);
-**   ... yadda ...
-**   PR_MemUnmap(addr);
-**   PR_CloseFileMap(fm);
-**
-**
-** Second Protocol:
-** Server:
-**
-**   fm = PR_OpenAnonFileMap(dirName, size, FilemapProt); 
-**   fmstring = PR_ExportFileMapAsString( fm );
-**   addr = PR_MemMap(fm); 
-**    ... application specific technique to pass fmstring to child
-**    ... yadda ... Server uses his own magic to create child
-**   PR_MemUnmap( addr );
-**   PR_CloseFileMap(fm);
-**
-**
-** Client: 
-**   ... started by server via his own magic
-**   ... application specific technique to find fmstring from parent
-**   fm = PR_ImportFileMapFromString( fmstring )
-**   addr = PR_MemMap(fm);
-**   ... yadda ...
-**   PR_MemUnmap(addr);
-**   PR_CloseFileMap(fm);
-**
-**
-** lth. 2-Jul-1999.
-**
-** Note: The second protocol was requested by NelsonB (7/1999); this is
-** to accomodate servers which already create their own child processes
-** using platform native methods.
-** 
-*/
-
-#ifndef prshma_h___
-#define prshma_h___
-
-#include "prtypes.h"
-#include "prio.h"
-#include "prproces.h"
-
-#ifdef VBOX_WITH_XPCOM_NAMESPACE_CLEANUP
-#define PR_OpenAnonFileMap VBoxNsprPR_OpenAnonFileMap
-#define PR_ProcessAttrSetInheritableFileMap VBoxNsprPR_ProcessAttrSetInheritableFileMap
-#define PR_GetInheritedFileMap VBoxNsprPR_GetInheritedFileMap
-#define PR_ExportFileMapAsString VBoxNsprPR_ExportFileMapAsString
-#define PR_ImportFileMapFromString VBoxNsprPR_ImportFileMapFromString
-#endif /* VBOX_WITH_XPCOM_NAMESPACE_CLEANUP */
-
-PR_BEGIN_EXTERN_C
-
-/*
-** PR_OpenAnonFileMap() -- Creates an anonymous file-mapped shared memory
-**
-** Description:
-** PR_OpenAnonFileMap() creates an anonymous shared memory. If the
-** shared memory already exists, a handle is returned to that shared
-** memory object.
-**
-** On Unix platforms, PR_OpenAnonFileMap() uses 'dirName' as a
-** directory name, without the trailing '/', to contain the anonymous
-** file. A filename is generated for the name.
-**
-** On Windows platforms, dirName is ignored.
-**
-** Inputs:
-**   dirName -- A directory name to contain the anonymous file.
-**   size -- The size of the shared memory
-**   prot -- How the shared memory is mapped. See prio.h
-**   
-** Outputs:
-**   PRFileMap *
-**
-** Returns:
-**   Pointer to PRFileMap or NULL on error.
-**
-*/
-NSPR_API( PRFileMap *)
-PR_OpenAnonFileMap(
-    const char *dirName,
-    PRSize      size, 
-    PRFileMapProtect prot
-);  
-
-/*
-** PR_ProcessAttrSetInheritableFileMap() -- Prepare FileMap for export  
-**   to my children processes via PR_CreateProcess()
-**
-** Description:
-** PR_ProcessAttrSetInheritableFileMap() connects the PRFileMap to
-** PRProcessAttr with shmname. A subsequent call to PR_CreateProcess()
-** makes the PRFileMap importable by the child process.
-**
-** Inputs:
-**   attr -- PRProcessAttr, used to pass data to PR_CreateProcess()
-**   fm -- PRFileMap structure to be passed to the child process
-**   shmname -- The name for the PRFileMap; used by child.
-**
-** Outputs:
-**   PRFileMap *
-**
-** Returns:
-**   PRStatus
-**
-*/
-NSPR_API(PRStatus) 
-PR_ProcessAttrSetInheritableFileMap( 
-    PRProcessAttr   *attr,
-    PRFileMap       *fm, 
-    const char      *shmname
-);
-
-/*
-** PR_GetInheritedFileMap() -- Import a PRFileMap previously exported
-**   by my parent process via PR_CreateProcess()
-**
-** Description:
-** PR_GetInheritedFileMap() retrieves a PRFileMap object exported from
-** its parent process via PR_CreateProcess().
-**
-** Inputs:
-**    shmname -- The name provided to PR_ProcessAttrSetInheritableFileMap()
-** 
-** Outputs:
-**   PRFileMap *
-**
-** Returns:
-**   PRFileMap pointer or NULL.
-**
-*/
-NSPR_API( PRFileMap *)
-PR_GetInheritedFileMap( 
-    const char *shmname 
-);
-
-/*
-** PR_ExportFileMapAsString() -- Creates a string identifying a PRFileMap
-**
-** Description:
-** Creates an identifier, as a string, from a PRFileMap object
-** previously created with PR_OpenAnonFileMap().
-**
-** Inputs:
-**   fm -- PRFileMap pointer to be represented as a string.
-**   bufsize -- sizeof(buf)
-**   buf -- a buffer of length PR_FILEMAP_STRING_BUFSIZE
-**
-** Outputs:
-**   buf contains the stringized PRFileMap identifier
-**
-** Returns:
-**   PRStatus
-**
-*/
-NSPR_API( PRStatus )
-PR_ExportFileMapAsString( 
-    PRFileMap *fm,
-    PRSize    bufsize,
-    char      *buf
-);
-#define PR_FILEMAP_STRING_BUFSIZE 128
-
-/*
-** PR_ImportFileMapFromString() -- Creates a PRFileMap from the identifying string
-**
-** Description:
-** PR_ImportFileMapFromString() creates a PRFileMap object from a
-** string previously created by PR_ExportFileMapAsString().
-**
-** Inputs:
-**   fmstring -- string created by PR_ExportFileMapAsString()
-**
-** Returns:
-**   PRFileMap pointer or NULL.
-**
-*/
-NSPR_API( PRFileMap * )
-PR_ImportFileMapFromString( 
-    const char *fmstring
-);
-
-PR_END_EXTERN_C
-#endif /* prshma_h___ */
Index: trunk/src/libs/xpcom18a4/nsprpub/pr/src/md/unix/uxshm.c
===================================================================
--- trunk/src/libs/xpcom18a4/nsprpub/pr/src/md/unix/uxshm.c	(revision 101840)
+++ trunk/src/libs/xpcom18a4/nsprpub/pr/src/md/unix/uxshm.c	(revision 101841)
@@ -482,177 +482,2 @@
 #endif
 
-
-
-/*
-** Unix implementation for anonymous memory (file) mapping
-*/
-extern PRLogModuleInfo *_pr_shma_lm;
-
-#include <unistd.h>
-
-extern PRFileMap* _md_OpenAnonFileMap( 
-    const char *dirName,
-    PRSize      size,
-    PRFileMapProtect prot
-)
-{
-    PRFileMap   *fm = NULL;
-    PRFileDesc  *fd;
-    int         osfd;
-    PRIntn      urc;
-    PRIntn      mode = 0600;
-    char        *genName;
-    pid_t       pid = getpid(); /* for generating filename */
-    PRThread    *tid = PR_GetCurrentThread(); /* for generating filename */
-    int         incr; /* for generating filename */
-    const int   maxTries = 20; /* maximum # attempts at a unique filename */
-    PRInt64     size64; /* 64-bit version of 'size' */
-
-    /*
-    ** generate a filename from input and runtime environment
-    ** open the file, unlink the file.
-    ** make maxTries number of attempts at uniqueness in the filename
-    */
-    for ( incr = 0; incr < maxTries ; incr++ ) {
-        genName = PR_smprintf( "%s/.NSPR-AFM-%d-%p.%d", 
-            dirName, (int) pid, tid, incr );
-        if ( NULL == genName ) {
-            PR_LOG( _pr_shma_lm, PR_LOG_DEBUG,
-                ("_md_OpenAnonFileMap(): PR_snprintf(): failed, generating filename"));
-            goto Finished;
-        }
-        
-        /* create the file */
-        osfd = open( genName, (O_CREAT | O_EXCL | O_RDWR), mode );
-        if ( -1 == osfd ) {
-            if ( EEXIST == errno )  {
-                PR_smprintf_free( genName );
-                continue; /* name exists, try again */
-            } else {
-                _PR_MD_MAP_OPEN_ERROR( errno );
-                PR_LOG( _pr_shma_lm, PR_LOG_DEBUG,
-                    ("_md_OpenAnonFileMap(): open(): failed, filename: %s, errno: %d", 
-                        genName, PR_GetOSError()));
-                PR_smprintf_free( genName );
-                goto Finished;
-            }
-        }
-        break; /* name generation and open successful, break; */
-    } /* end for() */
-
-    if ( incr == maxTries ) {
-        PR_ASSERT( -1 == osfd );
-        PR_ASSERT( EEXIST == errno );
-        _PR_MD_MAP_OPEN_ERROR( errno );
-        goto Finished;
-    }
-
-    urc = unlink( genName );
-    if ( -1 == urc ) {
-        _PR_MD_MAP_UNLINK_ERROR( errno );
-        PR_LOG( _pr_shma_lm, PR_LOG_DEBUG,
-            ("_md_OpenAnonFileMap(): failed on unlink(), errno: %d", errno));
-        PR_smprintf_free( genName );
-        close( osfd );
-        goto Finished;        
-    }
-    PR_LOG( _pr_shma_lm, PR_LOG_DEBUG,
-        ("_md_OpenAnonFileMap(): unlink(): %s", genName ));
-
-    PR_smprintf_free( genName );
-
-    fd = PR_ImportFile( osfd );
-    if ( NULL == fd ) {
-        PR_LOG( _pr_shma_lm, PR_LOG_DEBUG,
-            ("_md_OpenAnonFileMap(): PR_ImportFile(): failed"));
-        goto Finished;        
-    }
-    PR_LOG( _pr_shma_lm, PR_LOG_DEBUG,
-        ("_md_OpenAnonFileMap(): fd: %p", fd ));
-
-    urc = ftruncate( fd->secret->md.osfd, size );
-    if ( -1 == urc ) {
-        _PR_MD_MAP_DEFAULT_ERROR( errno );
-        PR_LOG( _pr_shma_lm, PR_LOG_DEBUG,
-            ("_md_OpenAnonFileMap(): failed on ftruncate(), errno: %d", errno));
-        PR_Close( fd );
-        goto Finished;        
-    }
-    PR_LOG( _pr_shma_lm, PR_LOG_DEBUG,
-        ("_md_OpenAnonFileMap(): ftruncate(): size: %d", size ));
-
-    LL_UI2L(size64, size);  /* PRSize (size_t) is unsigned */
-    fm = PR_CreateFileMap( fd, size64, prot );
-    if ( NULL == fm )  {
-        PR_LOG( _pr_shma_lm, PR_LOG_DEBUG,
-            ("PR_OpenAnonFileMap(): failed"));
-        PR_Close( fd );
-        goto Finished;        
-    }
-    fm->md.isAnonFM = PR_TRUE; /* set fd close */
-
-    PR_LOG( _pr_shma_lm, PR_LOG_DEBUG,
-        ("_md_OpenAnonFileMap(): PR_CreateFileMap(): fm: %p", fm ));
-
-Finished:    
-    return(fm);
-} /* end md_OpenAnonFileMap() */
-
-/*
-** _md_ExportFileMapAsString()
-**
-**
-*/
-extern PRStatus _md_ExportFileMapAsString(
-    PRFileMap *fm,
-    PRSize    bufSize,
-    char      *buf
-)
-{
-    PRIntn  written;
-    PRIntn  prot = (PRIntn)fm->prot;
-    
-    written = PR_snprintf( buf, bufSize, "%ld:%d",
-        fm->fd->secret->md.osfd, prot );
-        
-    return((written == -1)? PR_FAILURE : PR_SUCCESS);
-} /* end _md_ExportFileMapAsString() */
-
-
-extern PRFileMap * _md_ImportFileMapFromString(
-    const char *fmstring
-)
-{
-    PRStatus    rc;
-    PRInt32     osfd;
-    PRIntn      prot; /* really: a PRFileMapProtect */
-    PRFileDesc  *fd;
-    PRFileMap   *fm = NULL; /* default return value */
-    PRFileInfo64 info;
-
-    PR_sscanf( fmstring, "%ld:%d", &osfd, &prot );
-
-    /* import the os file descriptor */
-    fd = PR_ImportFile( osfd );
-    if ( NULL == fd ) {
-        PR_LOG( _pr_shma_lm, PR_LOG_DEBUG,
-            ("_md_ImportFileMapFromString(): PR_ImportFile() failed"));
-        goto Finished;
-    }
-
-    rc = PR_GetOpenFileInfo64( fd, &info );
-    if ( PR_FAILURE == rc )  {
-        PR_LOG( _pr_shma_lm, PR_LOG_DEBUG,
-            ("_md_ImportFileMapFromString(): PR_GetOpenFileInfo64() failed"));    
-        goto Finished;
-    }
-
-    fm = PR_CreateFileMap( fd, info.size, (PRFileMapProtect)prot );
-    if ( NULL == fm ) {
-        PR_LOG( _pr_shma_lm, PR_LOG_DEBUG,
-            ("_md_ImportFileMapFromString(): PR_CreateFileMap() failed"));    
-    }
-
-Finished:
-    return(fm);
-} /* end _md_ImportFileMapFromString() */
Index: trunk/src/libs/xpcom18a4/nsprpub/pr/src/memory/prshma.c
===================================================================
--- trunk/src/libs/xpcom18a4/nsprpub/pr/src/memory/prshma.c	(revision 101840)
+++ 	(revision )
@@ -1,142 +1,0 @@
-/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
-/* ***** BEGIN LICENSE BLOCK *****
- * Version: MPL 1.1/GPL 2.0/LGPL 2.1
- *
- * The contents of this file are subject to the Mozilla Public License Version
- * 1.1 (the "License"); you may not use this file except in compliance with
- * the License. You may obtain a copy of the License at
- * http://www.mozilla.org/MPL/
- *
- * Software distributed under the License is distributed on an "AS IS" basis,
- * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
- * for the specific language governing rights and limitations under the
- * License.
- *
- * The Original Code is the Netscape Portable Runtime (NSPR).
- *
- * The Initial Developer of the Original Code is
- * Netscape Communications Corporation.
- * Portions created by the Initial Developer are Copyright (C) 1998-2000
- * the Initial Developer. All Rights Reserved.
- *
- * Contributor(s):
- *
- * Alternatively, the contents of this file may be used under the terms of
- * either the GNU General Public License Version 2 or later (the "GPL"), or
- * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
- * in which case the provisions of the GPL or the LGPL are applicable instead
- * of those above. If you wish to allow use of your version of this file only
- * under the terms of either the GPL or the LGPL, and not to allow others to
- * use your version of this file under the terms of the MPL, indicate your
- * decision by deleting the provisions above and replace them with the notice
- * and other provisions required by the GPL or the LGPL. If you do not delete
- * the provisions above, a recipient may use your version of this file under
- * the terms of any one of the MPL, the GPL or the LGPL.
- *
- * ***** END LICENSE BLOCK ***** */
-
-/*
-** prshma.h -- NSPR Anonymous Shared Memory
-**
-** 
-*/
-
-#include "primpl.h"
-
-extern PRLogModuleInfo *_pr_shma_lm;
-
-#if defined(XP_UNIX)
-/* defined in pr/src/md/unix/uxshm.c */
-#elif defined(WIN32)
-/* defined in pr/src/md/windows/w32shm.c */
-#else
-extern PRFileMap * _PR_MD_OPEN_ANON_FILE_MAP( const char *dirName, PRSize size, PRFileMapProtect prot )
-{
-    PR_SetError(PR_NOT_IMPLEMENTED_ERROR, 0);
-    return NULL;
-}
-extern PRStatus _PR_MD_EXPORT_FILE_MAP_AS_STRING(PRFileMap *fm, PRSize bufSize, char *buf)
-{
-    PR_SetError(PR_NOT_IMPLEMENTED_ERROR, 0);
-    return PR_FAILURE;
-}
-extern PRFileMap * _PR_MD_IMPORT_FILE_MAP_FROM_STRING(const char *fmstring)
-{
-    PR_SetError(PR_NOT_IMPLEMENTED_ERROR, 0);
-    return NULL;
-}
-#endif
-
-/*
-** PR_OpenAnonFileMap() -- Creates an anonymous file-mapped shared memory
-**
-*/
-PR_IMPLEMENT(PRFileMap*)
-PR_OpenAnonFileMap(
-    const char *dirName,
-    PRSize      size, 
-    PRFileMapProtect prot
-)
-{
-    return(_PR_MD_OPEN_ANON_FILE_MAP( dirName, size, prot ));
-} /* end PR_OpenAnonFileMap() */
-
-/*
-** PR_ProcessAttrSetInheritableFileMap() -- Prepare FileMap for export  
-**   to my children processes via PR_CreateProcess()
-**
-**
-*/
-PR_IMPLEMENT( PRStatus) 
-PR_ProcessAttrSetInheritableFileMap( 
-    PRProcessAttr   *attr,
-    PRFileMap       *fm, 
-    const char      *shmname
-)
-{
-    PR_SetError( PR_NOT_IMPLEMENTED_ERROR, 0 );
-    return( PR_FAILURE);
-} /* end PR_ProcessAttrSetInheritableFileMap() */ 
-
-/*
-** PR_GetInheritedFileMap() -- Import a PRFileMap previously exported
-**   by my parent process via PR_CreateProcess()
-**
-*/
-PR_IMPLEMENT( PRFileMap *)
-PR_GetInheritedFileMap( 
-    const char *shmname 
-)
-{
-    PRFileMap   *fm = NULL;
-    PR_SetError( PR_NOT_IMPLEMENTED_ERROR, 0 );
-    return( fm );
-} /* end PR_GetInhteritedFileMap() */
-
-/*
-** PR_ExportFileMapAsString() -- Creates a string identifying a PRFileMap
-**
-*/
-PR_IMPLEMENT( PRStatus )
-PR_ExportFileMapAsString( 
-    PRFileMap *fm,
-    PRSize    bufSize,
-    char      *buf
-)
-{
-    return( _PR_MD_EXPORT_FILE_MAP_AS_STRING( fm, bufSize, buf ));
-} /* end PR_ExportFileMapAsString() */
-
-/*
-** PR_ImportFileMapFromString() -- Creates a PRFileMap from the identifying string
-**
-**
-*/
-PR_IMPLEMENT( PRFileMap * )
-PR_ImportFileMapFromString( 
-    const char *fmstring
-)
-{
-    return( _PR_MD_IMPORT_FILE_MAP_FROM_STRING(fmstring));
-} /* end PR_ImportFileMapFromString() */
-/* end prshma.c */